function init(hero) {
    hero.setName("Spider-Man");
	  hero.setVersion("Ultimate");
    hero.setTier(6);
    
    hero.setHelmet("item.superhero_armor.piece.mask");
    hero.setChestplate("item.superhero_armor.piece.chestpiece");
    hero.setLeggings("item.superhero_armor.piece.pants");
    hero.setBoots("item.superhero_armor.piece.boots");
    
    hero.addPowers("pack:spider_physiology", "pack:web_shooters_ultimate");
          hero.addAttribute("WEAPON_DAMAGE", 9, 0);
    hero.addAttribute("PUNCH_DAMAGE", 14, 0);
    hero.addAttribute("FALL_RESISTANCE", 40.0, 0);
    hero.addAttribute("JUMP_HEIGHT", 3.25, 0);
    hero.addAttribute("SPRINT_SPEED", 1.35, 1);
    hero.addAttribute("STEP_HEIGHT", 1.5, 0);
    hero.addAttribute("IMPACT_DAMAGE", 0.6, 1);
    
       hero.addKeyBind("UTILITY_BELT", "key.webShooters", 1);   
    hero.addKeyBind("WEB_ZIP", "key.webZip", 2);
    hero.addKeyBindFunc("func_WEB_SWINGING", webSwingingKey, "key.webSwinging", 3);
	    hero.addKeyBind("CHARGED_BEAM", "BioElectric Blast", 4);
	  hero.addKeyBind("INVISIBILITY", "key.invisibility", 5);  

		 hero.setDefaultScale(0.94);
		     hero.setModifierEnabled(isModifierEnabled);
    hero.setKeyBindEnabled(isKeyBindEnabled);
		hero.setHasProperty(hasProperty);
}

function webSwingingKey(player, manager) {
    var flag = player.getData("fiskheroes:web_swinging");
    
    if (!flag) {
        manager.setDataWithNotify(player, "fiskheroes:prev_utility_belt_type", player.getData("fiskheroes:utility_belt_type"));
        manager.setDataWithNotify(player, "fiskheroes:utility_belt_type", -1);
    }
    
    manager.setDataWithNotify(player, "fiskheroes:web_swinging", !flag);
    return true;
}

function isModifierEnabled(entity, modifier) {
    switch (modifier.name()) {
    case "fiskheroes:web_swinging":
        return entity.getHeldItem().isEmpty() && entity.getData("fiskheroes:utility_belt_type") == -1;
    case "fiskheroes:leaping":
        return modifier.id() == "springboard" == (entity.getData("fiskheroes:ticks_since_swinging") < 5);
    default:
        return true;
    }
}

function isKeyBindEnabled(entity, keyBind) {
    switch (keyBind) {
    case "func_WEB_SWINGING":
        return entity.getHeldItem().isEmpty();
    default:
        return true;
    }
}


function hasProperty(entity, property) {
    return property == "MASK_TOGGLE" || !entity.getData("fiskheroes:mask_open");
}